/* bxbasm : Prototyp.h : alpha version */
/* ----- function prototypes ----- */

/*------ Error.c ------*/
    void a_bort(int,int);
    void err_hndlr(int,int,int,int,int);
    void dump(void);


/*------ Input.c ------*/
    void line_cnt(char *argv[]);
    void load_src(void);
    void save_tmp(void);
    void tmp_byte(int);
    void loader_1(void);
    void tmp_label(int);
    void tmp_byte(int);
     int get_byte(int);
    void tmp_prog(int);
    void loader_2(void);
    void get_MOD(int);
    void token_if(int);
    void str_functn(int);
     int IsEqu(int);
    void get_strfunc(char *,int);
    void str_copy(char *,int);
    void str_funct2(int);
    void get_mathfunc(char *,int);
    void var_types(int);


/*------ Utility.c ------*/
     int get_upper(int,int);
     int get_alpha(int,int);
     int get_digit(int,int);
     int iswhite(int);
    void clr_arrays(void);
     int iswhiter(int);
     int find_strng(char *);
     int get_paren(int,int);
     int get_NextOp(int);
     int get_Nvtype(int);
     int get_vtype(int);
     int get_rightExp(int);
     int get_alnum(int,int);
     int while_isalnum(int);
     int get_quote(int,int);
    void Build_arrays(void);
    void Kill_arrays(void);
     int get_Dvtype(int);



/*------ Asmfile.c ------*/
    void init_fldbffrs(void);
    void parse_open(void);
    void Do_fclose(void);
    void write_io(void);
    void input_io(void);
    void Do_field(void);
    void Do_lset(void);
    void Do_put(void);
    void Do_get(void);
    void Do_rset(void);
    void lineinput_io(void);
    void print_file(int);
    void parse_shell(void);
    void parse_chd(void);
    void parse_mkd(void);
    void parse_rmd(void);
    void parse_kill(void);
    void parse_name(void);
    void parse_chdrive(void);
    void Do_lprint(void);




/*------ Asmstrng.c ------*/
    void parse_str(char *);
    void str_express(char *);
    void cat_string(int);
    void copy_string(int);
    void asn_function(int);
    void cat_function(int);
    void string_functions(int,int);
    void chrstr(int);
    void leftstr(int);
    void rightstr(int);
    void midstr(int);
    void spacestr(int);
    void strsval(int);
    void stringstr(int);
    void inkeystr(void);
    void inputstr(int);
    void mkistr(int);
    void mkdstr(int);
    void datestr(void);
    void timestr(void);
    void asn_strarry(void);
    void cat_strarry(void);



/*------ Asmif.c ------*/
    void Do_if(void);
    void Do_elseif(void);
    void Do_else(void);
    void Do_endif(void);
     int check_or(void);
    void or_true(int);
    void check_lsif(void);
    void check_else(void);
    void boolexpress(void);
     int Nboolterm(int);
     int Nrelation(void);
     int get_op(void);
     int IsAndOrOp(int);
     int get_Exptype(void);
     int look_Or(void);
    char *jump_if(int,char);
     int Sboolterm(int);
     int Srelation(void);
     int if_eof(void);
     int is_eof(void);



/*------ Asminput.c ------*/
    void Header(void);
    void open_destin(void);
    void Prolog(void);
    void ScanVars(void);
    void Epilog(void);
    void assemble(void);
    void ScanLet(void);
    void ScanPrint(void);
    void SystemConst(void);
    void ScanString(char *);
    void load_tmpdata(void);
    void ScanFor(void);
    void ScanIf(void);
     int scanStr_funct(int);
    void ScanFiles(void);
    void ScanShell(void);
    void ScanRename(void);
    void ScanErase(void);




/*------ AsmNInpt.c ------*/
    char *NewFVarname(void);
    void StorNVar(char *);
    void GetNewTmp(void);
    void AddNewVar(void);
    void Sav_Destin(int,char *);
    void ScanMathFunc(int);
    void ScanNumeric(char *);
    void LexFor(char *);
    void LexTo(void);
    void LexStep(int);
    void defaultStep(int);
    void ScanParam(void);
    void ScanJump(void);
    void ScanOpen(void);
    void ScanWrite(void);
    void ScanFInput(void);
    void ScanField(void);
    void ScanPut(void);
    void ScanFPrint(void);
    void ScanLPrint(void);



/*------ Asmrdp.c ------*/
    void Assignment(void);
    void a_Expression(void);
    void a_Term(void);
    void a_Factor(void);
    void Ident(void);
    void Add(void);
    void Subtract(void);
    void Multiply(void);
    void Divide(void);
    void Power(void);
    void Modulo(void);
    void Match(char);
    void _GetChar(void);
     int IsAddop(char);
     int IsMultop(char);
     int Is_White(char);
    void SkipWhite(void);
    void math_functn(void);
    void get_ABS(void);
    void get_ASC(void);
    void get_ATN(void);
    void get_COS(void);
    void get_SIN(void);
    void get_TAN(void);
    void get_SQRT(void);
    void get_INT(void);
    void get_LEN(void);
    void get_CVD(void);
    void get_CVI(void);
    void get_ATN2(void);
    void get_COSH(void);
    void get_SINH(void);
    void get_TANH(void);
    void get_ACOS(void);
    void get_ASIN(void);
    void get_CEIL(void);
    void get_FLOOR(void);
    void get_HYPOT(void);
    void get_LOG(void);
    void get_LOG10(void);
    void get_RAND(void);
    void seed_rand(void);
    void get_CLOCK(void);
    void get_VAL(void);
    void get_LOC(void);
    void get_LOF(void);
    void get_EOF(void);
    void asn_numarry(char *,int);


/*------ Asmloops.c ------*/
    void Do_for(void);
    void Do_next(void);
    void Do_while(void);
    void Do_wend(void);
    void wboolexpress(void);
     int WNrelation(void);
     int WIsAndOrOp(int);
     int isUnary_Exp(void);
     int do_UnaryExp(int);
     int x_WNrelation(void);
     int Unary_NOT(void);
     int wcheck_or(void);
    void wor_true(int);
     int Unary_TRUE(void);
    void Do_loop(void);
    void Do_endloop(void);
    void Do_break(void);
    void Do_do(void);
    void Do_dowhile(void);




/*------ Asmfunct.c ------*/
    void Do_initialize(void);
    void Do_cls(void);
    void Do_end(void);
    void Do_beep(void);
    void Do_print(void);
    void prn_expression(void);

    void Do_goto(void);
    void Do_label(void);
    void Do_gosub(void);
    void Do_return(void);
    void Do_locate(void);
    void Do_functions(void);
    void copystrng_bffr(void);
    void func_chrstr(void);
    void func_leftstr(void);
    void func_rightstr(void);
    void func_midstr(void);
    void func_spacestr(void);
    void func_strsIval(void);
    void func_strsFval(void);
    void func_stringstr(void);
    void func_inkeystr(void);
    void func_inputstr(void);
    void func_mkistr(void);
    void func_mkdstr(void);
    void func_mkqstr(void);
    void func_wherexy(void);
    void func_resetcursor(void);
    void func_getsysdate(void);
    void func_getsystime(void);
    void func_datestr(void);
    void func_timestr(void);
    void prn_function(int);
    void func_closeallfiles(void);
    void func_closeafile(void);
    void func_getfilehandle(void);
    void func_clearstrng_bffr(void);
    void func_setupiobuffer(void);
    void func_lsetstr(void);
    void func_rsetstr(void);
    void func_clear_allvars(void);
    void func_clearstrvar(void);
    void func_clearintvar(void);
    void func_clearfltvar(void);
    void func_clearLngstrng_bffr(void);
    void func_movstrng_bffr(void);
    void func_readintstr(void);
    void func_readfltstr(void);
    void func_readQintstr(void);
    void func_getfilelength(void);
    void func_setcolortext(void);
    void func_dimstrarray(void);
    void func_getArryOffst(void);
    void prn_strarry(char *,int);
    void func_dblArryElement(void);
    void func_quadArryElement(void);
    void func_freeArray(void);



/*------ Asmvars.c ------*/
    void Do_let(void);
    void asn_integer(int,char *);
    void asn_float(int,char *);
    void get_input(void);
    void get_lninput(void);
    void clr_vars(void);
    void Do_color(void);
    void Do_dim(void);
    void parse_strArry(char *);
    void get_offset(char *,int,int);
    void parse_intArry(char *,int);
    void parse_fltArry(char *,int);
    void Do_erase(void);



/*------ Asmutils.c ------*/
    void PostLabel(char *);
    char *get_varname(void);
    char *get_NewLabel(void);
    void writeln(char *);
    void write_str(char *);
    void s_writeln(char *);
    void s_write_str(char *);
    void i_writeln(char *);
    void i_write_str(char *);
    void f_writeln(char *);
    void f_write_str(char *);
    void x_write_str(char *);
    void x_writeln(char *);
  double get_avalue(void);
    void Do_asm(void);
     int check_arrayName(char *);
    void InitArrays(void);
     int get_paramsCount(int,int);
     int verify_arrayName(char *);
     int check_VarName(char *);
    void InitVars(void);
     int verify_VarName(char *);
    void InitObj(void);
    void Sav_ObjName(char *,int,int);
     int get_ObjectType(char *);
     int get_ObjectParm(char *);
    void GetNewVar(void);
    void StorVar(char *);
    void Sav_String(char *);
    void Fix_String(char *);
    char *NewVarname(void);
    void Fix_VarName(char *,int);
    void Fix_StrArray(char *);
    void Fix_VarArray(char *);
    void Fix_StrArray2(char *);
    void Fix_VarArray2(char *,int);
     int relocate(int,int);
    void Fix_StrArray3(char *,int);
    void Fix_VarArray3(char *,int,int);




/*------ AsmDInpt.c ------*/
    void ScanDim(void);
    void ScanStrArray(char *);
    void ScanArrayParam(void);
    void ScanNumArray(char *,int);
    void Scan_Array(char *,int);
    void Scan_Var(char *);
    void Scan_Obj(char *);



