$CCODE
/* bxbasm : AsmDInpt.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"



void Scan_Obj(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, xcnt, type, ab_code=20, x=line_ndx;

/* printf("->scanobj::%s", p_string); */
    strcpy(varname, Name);
    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    xcnt = get_paramsCount(pi, len);	/* get params count */
    pi++;
    pi = get_paren(pi, len);
    pi++;
    pi = iswhiter(pi);
    ch = p_string[pi];
    switch(ch)
    {   case '$':
            type = 6;			/* string array */
            break;
        case '%':
            type = 7;			/* integer array */
            break;
        case '!':
            type = 8;			/* float array */
            break;
        case '#':
            type = 9;			/* double array */
            break;
        case '@':
        case '&':
            type = 10;			/* long integer */
            break;
        default:
            type = 7;			/* integer array */
            break;
    }
    if(check_VarName(varname) != 0)
    {   a_bort(ab_code,x);
    }
    if(check_arrayName(varname) == 0)
    {   x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");
    }
    Sav_ObjName(varname, type, xcnt);	/* save object name */
    p_string[pi] = ' ';
		/**/
    /* --- save p_string to array --- */
    strcpy(array1[line_ndx], p_string);   /* store to array */
		/**/
    pi = iswhiter(pi);
    e_pos = pi;
/* printf("%s", p_string); */
}
/*---------- end Scan_Obj ----------*/


void Scan_Var(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, pend, pstart;

/* printf("->scanvar::%s", p_string); */
    strcpy(varname, Name);
    pstart = s_pos;
    pi = e_pos;
    pend = pi;
    pi = iswhiter(pi);
    ch = p_string[pi];
    if(ch == '$')					/* string variable -or- array */
    {   p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];
        if(ch == '*')					/* a string array */
        {   e_pos = pend;
            Fix_StrArray2(varname);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {   p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_String(varname);
            StorVar(varname);
        }
    }
    else if(ch == '%')				/* integer variable -or- array */
    {   p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];
        if(ch == '*')					/* a integer array */
        {   e_pos = pend;
            Fix_VarArray2(varname, 7);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {   p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(2, varname);
        }
    }
    else if(ch == '!')				/* single variable -or- array */
    {   p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];
        if(ch == '*')					/* an array */
        {   e_pos = pend;
            Fix_VarArray2(varname, 8);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {   p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(3, varname);
        }
    }
    else if(ch == '#')				/* double variable -or- array */
    {   p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];
        if(ch == '*')					/* an array */
        {   e_pos = pend;
            Fix_VarArray2(varname, 9);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {   p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(4, varname);
        }
    }
    else if((ch == '&') || (ch == '@'))	/* long variable -or- array */
    {   p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];
        if(ch == '*')					/* an array */
        {   e_pos = pend;
            Fix_VarArray2(varname, 10);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {   p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(5, varname);
        }
    }
/* printf("<-scanvar::\n%s", p_string); */
}
/*---------- end Scan_Var ----------*/


void ScanDim()
{   char ch, varname[VAR_NAME];
    int pi, start, len, xcnt, type, ab_code=20, x=line_ndx;

/* printf("DIM::%s", p_string); */
    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    while((pi < len) && (ch != '\n'))
    {   start = e_pos;
        strcpy(varname, get_varname());
		/**/
        pi = e_pos;
        type = get_Dvtype(pi);
  /* printf("type=%d\n", type); */

        e_pos = pi;
        if(type == 0)					/* character string */
        {   p_string[pi] = ' ';
            s_pos = start;
            Sav_String(varname);
            StorVar(varname);
        }
        else if(type == 1)				/* name AS datatype */
        {   s_pos = start;
            Scan_Var(varname);
        }
        else if((type >= 2) && (type <= 5))	/* numeric variable */
        {   s_pos = start;
            Sav_Destin(type, varname);
        }
        else if(type == 6)			/* character string array */
        {   Fix_StrArray3(varname, len);
        }
        else if((type >= 7) && (type <= 10))		/* numeric array */
        {   Fix_VarArray3(varname, type, len);
        }
        else if(type == 11)				/* name AS datatype */
        {   s_pos = start;
            Scan_Obj(varname);
        }
        else
        {   ab_code = 25;			/* not a recognized object */
            a_bort(ab_code, x);
        }
        len = strlen(p_string);
        pi = e_pos;
        ch = p_string[pi];
        pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;

    }
/* printf("dim::%s", p_string); */
}
/*---------- end ScanDim ----------*/


void Scan_Array(char *name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len;

    strcpy(varname, name);
    pi = e_pos;
    ch = p_string[pi];
    if(strchr("%!#@&", ch))
    {   p_string[pi] = ' ';
        e_pos++;
    }
    StorNVar(varname);			/* save destination array name */
		/**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    e_pos = pi;
    ScanArrayParam();			/* assign variables: abc%(1,3,n) */
}
/*---------- end Scan_Array ----------*/


void ScanNumArray(char *name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len, ival, funcflag=0, ab_code=21, x=line_ndx;

/* printf("SNA::%s", p_string); */
    strcpy(varname, name);
    pi = e_pos;
    s_pos = 0;
    Scan_Array(varname, type);
		/**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_rightExp(pi);			/* jump pi over this operator */
    ch = p_string[pi];
    while((ch != '\n') && (pi < len))
    {   ch = p_string[pi];
        while((isalnum(ch) == 0) && (pi < len) && (strchr(".\"",ch) == 0))
        {   pi++;
            ch = p_string[pi];
            if(ch == '?')			/* math function: ?1(num) */
            {   e_pos = pi + 1;
                ival = (int) get_avalue();
                if((ival == 10) || (ival == 11) || (ival == 29))
                {   pi = len;				/* LOC, LOF, EOF */
                }
                else					/* any other function */
                {   pi = get_paren(pi, len);	/* ?num(string$) */
                    ch = p_string[pi];		/* ----^	     */
                    funcflag = 1;
                }
            }
        }
        if(pi < len)
        {   e_pos = pi;
            if(funcflag == 1)			/* this is a math function */
            {   ScanMathFunc(len);
                funcflag = 0;
            }
            else if((isdigit(ch)) || (ch == '.'))
            {   GetNewTmp();			/* get new temp varname */
            }
            else if(isalpha(ch))		/* an array or variable name */
            {   pi = e_pos;
                strcpy(varname, get_varname());		/* get varname */
                type = get_ObjectType(varname);
				/**/
                if((type >= 7) && (type <= 10))		/* an array name */
                {   Fix_VarArray(varname);
                    pi = e_pos;
                    pi = get_paren(pi, len);
                    ScanArrayParam();
                }
                else
                {   e_pos = pi;
                    AddNewVar();			/* a variable name */
                }
            }
            else
            {   a_bort(ab_code, x);
            }
            pi = e_pos;
            len = strlen(p_string);
        }
    }
/* printf("sna::%s", p_string); */
}
/*---------- end ScanNumArray ----------*/


void ScanArrayParam()
{   char ch;
    int pi;

    pi = e_pos;
    ch = p_string[pi];
    while(ch != ')')
    {   e_pos = pi;
        if(isalpha(ch))
        {   AddNewVar();
            pi = e_pos;
        }
        else
        {   pi++;
        }
        ch = p_string[pi];
    }
    e_pos = pi;
}
/*---------- end ScanArrayParam ----------*/

$CCODE