$CCODE
/* bxbasm : AsmNInpt.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"




void ScanLPrint()					/* parse LPRINT statement */
{   char ch, NVar[12], varname[VAR_NAME], format[BUFSIZE];
    int pi, len, type, wflag=0, ii;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    format[0] = '\0';
		/**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {   pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();			/* get new varname */
            strcat(format, "%s");
        }
        else
        {   type = get_vtype(pi);
            if(type == 0)
            {   e_pos = pi;
                strcpy(varname, get_varname());		/* get varname */
                Fix_String(varname);
                strcat(format, "%s");
            }
            else			  				/* output a value */
            {   e_pos = pi;
                type = get_Nvtype(pi);
                AddNewVar();
				/**/
                if(type < 3)
                {   strcat(format, " %d");
                }
                else if(type < 5)
                {   strcat(format, " %f");
                }
                else
                {   strcat(format, " %lu");
                }
            }
        }
        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr("$#!%@&", ch))
        {   pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
        }
    }
/* printf("format=%s\n", format); */

  /* --- get new varname --- */
    strcpy(NVar, NewFVarname());
    strcat(NVar, "S");
    write_str("\t");
    write_str(NVar);
    write_str("\t\tDB\t\'");
    write_str(format);
    writeln("\',10,0");
		/**/
    strcpy(format, "#");
    strcat(format, NVar);
    strcat(format, ", ");
    strcat(format, p_string);
		/**/
/* --- save p_string to array --- */
    len = strlen(format);
    size = len + 1;
    ii = line_ndx;
    array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], format);   			/* store to array */

  /* printf("p_string:%s", format); */
}
/*------- end ScanLPrint ----------*/


void ScanFPrint()					/* parse PRINT# statement */
{   char ch, NVar[12], varname[VAR_NAME], format[BUFSIZE];
    int pi, len, type, wflag=0, ii;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    pi = get_NextOp(pi);
    ch = p_string[pi];
    format[0] = '\0';
		/**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {   pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();			/* get new varname */
            strcat(format, "%s");
        }
        else
        {   type = get_vtype(pi);
            if(type == 0)
            {   e_pos = pi;
                strcpy(varname, get_varname());		/* get varname */
                Fix_String(varname);
                strcat(format, "%s");
            }
            else			  				/* output a value */
            {   e_pos = pi;
                AddNewVar();
                type = get_Nvtype(pi);
                if(type < 3)
                {   strcat(format, " %d");
                }
                else if(type < 5)
                {   strcat(format, " %f");
                }
                else
                {   strcat(format, " %lu");
                }
            }
        }
        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr("$#!%@&", ch))
        {   pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
        }
    }
  /* printf("format=%s\n", format); */

  /* --- get new varname --- */
    strcpy(NVar, NewFVarname());
    strcat(NVar, "S");
    write_str("\t");
    write_str(NVar);
    write_str("\t\tDB\t\'");
    write_str(format);
    writeln("\',10,0");
		/**/
    strcpy(format, "#");
    strcat(format, NVar);
    strcat(format, ", ");
    strcat(format, p_string);
		/**/
/* --- save p_string to array --- */
    len = strlen(format);
    size = len + 1;
    ii = line_ndx;
    array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], format);   			/* store to array */

  /* printf("p_string:%s", format); */
}
/*------- end ScanFPrint ----------*/


void ScanPut()
{   char ch;
    int pi, len;

    pi = e_pos;
    len = strlen(p_string);
    pi = get_alnum(pi, len);
    pi = get_NextOp(pi);
    e_pos = pi;
		/**/
    ScanParam();						/* parse paramaters */
}
/*------- end ScanPut ----------*/



void ScanField()
{   char ch, temp[6], varname[VAR_NAME], string[BUFSIZE];
    int pi, len, mark, var_cnt=0, ii;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    strcpy(temp, " AS ");
		/**/
    while(pi < len)
    {   s_pos = pi;
        mark = find_strng(temp);
        mark--;
        if(mark > 0)
        {   pi = mark + 3;
            pi = iswhiter(pi);
            ch = p_string[pi];
            if(isalpha(ch))
            {   e_pos = pi;
                strcpy(varname, get_varname());		/* get varname */
                Fix_String(varname);
                var_cnt++;
            }
        }
        else
        {   pi = len;
        }
    }
    sprintf(temp, "%d", var_cnt);
    strcpy(string, temp);
    strcat(string, ",");
    strcat(string, p_string);
		/**/
/* --- save p_string to array --- */
    len = strlen(string);
    size = len + 1;
    ii = line_ndx;
    array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], string);   		/* store to array */
}
/*------- end ScanField ----------*/


void ScanFInput()					/* parse INPUT# statement */
{   char ch, NVar[12], varname[VAR_NAME];
    int pi, len, type, ii;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
		/**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {	  pi = get_alpha(pi, len);
        if(pi < len)
        {   type = get_vtype(pi);
            if(type == 0)
            {   e_pos = pi;
                strcpy(varname, get_varname());		/* get varname */
                Fix_String(varname);
            }
            else			  			/* output a value */
            {   e_pos = pi;
                AddNewVar();
            }
            pi = get_NextOp(pi);
        }
        ch = p_string[pi];
    }
 /* printf("p_string:%s", format); */

}
/*------- end ScanFInput ----------*/



void ScanWrite()					/* parse WRITE statement */
{   char ch, NVar[12], varname[VAR_NAME], format[BUFSIZE];
    int pi, len, type, wflag=0, ii;
    unsigned size;

/* printf("scanwrite: %s", p_string); */
    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    format[0] = '\0';
		/**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {	  pi = get_alpha(pi, len);
        if(pi < len)
        {   type = get_vtype(pi);
            if(type == 0)
            {   e_pos = pi;
                strcpy(varname, get_varname());		/* get varname */
                Fix_String(varname);
                if(wflag == 1)
                {   strcat(format, ",");
                }
                strcat(format, "%s");
                wflag = 1;
            }
            else			  			/* output a value */
            {   e_pos = pi;
                type = get_Nvtype(pi);
                AddNewVar();
				/**/
                if(wflag == 1)
                {   strcat(format, ",");
                }
                if(type < 3)
                {   strcat(format, "%d");
                }
                else if(type == 4)
                {   strcat(format, "%.20f");
                }
                else if(type == 3)
                {   strcat(format, "%f");
                }
                else /* if(type == 5) */
                {   strcat(format, "%lu");
                }
                wflag = 1;
            }
            pi = get_NextOp(pi);
        }
        ch = p_string[pi];
    }
 /* printf("format=%s\n", format); */
		/**/
    strcpy(NVar, NewFVarname());		/* --- get new varname --- */
    strcat(NVar, "S");
    write_str("\t");
    write_str(NVar);
    write_str("\t\tDB\t\'");
    write_str(format);
    writeln("\',10,0");
		/**/
    strcpy(format, NVar);
    strcat(format, ", ");
    strcat(format, p_string);
/* --- save p_string to array --- */
		/**/
    len = strlen(format);
    size = len + 1;
    ii = line_ndx;
    array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], format);   /* store to array */

/* printf("scanwrite:%s", format); */
}
/*------- end ScanWrite ----------*/


void ScanOpen()					/* parse OPEN statement */
{   char ch, temp[BUFSIZE];
    int pi, len, file, ii, ab_code=16, x=line_ndx;
    double value;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    if(ch != '\"')
    {   pi = get_quote(pi, len);
        pi--;
    }
    s_pos = pi;
    pi = get_upper(pi, len);
    ch = p_string[pi];
	/**/
    if(isalpha(ch))			/* isolate access mode: I,O,A,R (B) */
    {   switch(ch)
        {   case 'I':
                p_string[pi] = 'r';
                strcpy(temp, "0,");
                break;
            case 'O':
                p_string[pi] = 'w';
                strcpy(temp, "0,");
                break;
            case 'A':
                p_string[pi] = 'a';
                strcpy(temp, "0,");
                break;
            case 'R':
                p_string[pi] = 'r';
                p_string[(pi+1)] = 'b';
                p_string[(pi+2)] = '+';
                p_string[(pi+3)] = '\"';
                strcpy(temp, "1,");
                break;
            default:
                a_bort(ab_code,x);
                break;
        }
        e_pos = s_pos;
        GetNewVar();					/* get new varname */
        pi = e_pos;
    }
	/**/
    pi = get_digit(pi, len);			/* file number: #1,2,3... */
    ch = p_string[pi];
    if(isdigit(ch))
    {   pi = get_NextOp(pi);			/* skip over file number */
        pi = get_rightExp(pi);
    }
    else
    {   ab_code = 17;
        a_bort(ab_code,x);
    }
	/**/
    ch = p_string[pi];
    if(ch == '\"')
    {   e_pos = pi;
        GetNewVar();					/* get new varname */
    }
    else if(isalpha(ch))				/* a varname */
    {   /* do nothing, pass on varname */
    }
    else
    {   ab_code = 18;
        a_bort(ab_code,x);
    }
    strcat(temp, p_string);
		/**/
/* --- save p_string to array --- */
    len = strlen(temp);
    size = len + 1;
    ii = line_ndx;
    array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], temp);   /* store to array */
}
/*---------- end ScanOpen ----------*/


void ScanJump()			/* parse numeric jump label */
{   char ch, newlabel[LLEN], label[LLEN];
    int pi, len;

    pi = e_pos;
    len = strlen(p_string);
    pi = get_alnum(pi, len);
    if(pi < len)
    {   ch = p_string[pi];
        e_pos = pi;
        if(isdigit(ch))
        {   strcpy(newlabel, "L");		/* correct numeric label */
            strcpy(label, get_varname());
            strcat(newlabel, label);
            StorNVar(newlabel);		/* save new label name */
        }
    }
}
/*---------- end ScanJump ----------*/


void ScanParam()			/* parse function paramaters */
{   char ch;
    int pi, len;

    pi = e_pos;
    len = strlen(p_string);
    while(pi < len)
    {   pi = get_alnum(pi, len);
        ch = p_string[pi];
        if(pi < len)
        {   e_pos = pi;
            if((isdigit(ch)) || (ch == '.'))
            {   GetNewTmp();			/* get new temp varname */
            }
            else if(isalpha(ch))		/* a variable name */
            {   AddNewVar();
            }
            pi = e_pos;
            len = strlen(p_string);
        }
    }
}
/*---------- end ScanParam ----------*/


void defaultStep(int len)
{   char ch;
    int pi;

    pi = e_pos;
    len--;
    p_string[len] = '\0';
    strcat(p_string, " STEP 1\n");

  /* --- skip over STEP --- */
    len = strlen(p_string);
    pi = while_isalnum(pi);
    pi = get_digit(pi, len);

  /* --- convert digit to var-name --- */
    e_pos = pi;
    GetNewTmp();					/* get new temp varname */
}
/*---------- end defaultStep ----------*/


void LexStep(int len)
{   char ch;
    int pi;

    pi = e_pos;
    while(pi < len)
    {   ch = p_string[pi];
        while((isalnum(ch) == 0) && (pi < len))
        {   pi++;
            ch = p_string[pi];
        }
        if(pi < len)
        {   e_pos = pi;
            if(isdigit(ch))
            {   GetNewTmp();			/* get new temp varname */
            }
            else if(isalpha(ch))		/* a variable name */
            {   AddNewVar();
            }
            pi = e_pos;
        }
    }
}
/*---------- end LexStep ----------*/


void LexTo()
{   char ch;
    int pi, STEP;

    pi = e_pos;
    s_pos = pi;
    STEP = find_strng("STEP");			/* work up to: STEP */
    STEP--;
    if(STEP < 0)					/* if STEP does not exist */
    {   STEP = strlen(p_string);		/* use p_string length */
    }
    while(pi < STEP)
    {   ch = p_string[pi];
        while((isalnum(ch) == 0) && (pi < STEP))
        {   pi++;
            ch = p_string[pi];
        }
        if(pi < STEP)
        {   e_pos = pi;
            if(isdigit(ch))
            {   GetNewTmp();			/* get new temp varname */
            }
            else if(isalpha(ch))		/* a variable name */
            {   AddNewVar();
            }
            pi = e_pos;
            s_pos = pi;
            STEP = find_strng("STEP");	/* work up to: STEP */
            STEP--;
            if(STEP < 0)
            {   STEP = strlen(p_string);
            }
        }
    }
    e_pos = pi;
}
/*---------- end LexTo ----------*/


void LexFor(char *name)
{   char ch, varname[VAR_NAME];
    int pi, type, len, TO, ab_code=9, x=line_ndx;

    strcpy(varname, name);
    pi = e_pos;
    len = strlen(varname);
    s_pos = pi - len;
    type = get_Nvtype(pi);			/* get var-type length */
	/**/
    if((type == 1) || (type == 2))		/* must be type: integer */
    {   Sav_Destin(type, varname);		/* save destination name */
    }
    else
    {   a_bort(ab_code, x);
    }
    pi = e_pos;  					/* handle expresions */
    s_pos = pi;
    TO = find_strng("TO");			/* work up to: TO */
    TO--;
    while(pi < TO)
    {   ch = p_string[pi];
        while((isalnum(ch) == 0) && (pi < TO))
        {   pi++;
            ch = p_string[pi];
        }
        if(pi < TO)
        {   e_pos = pi;
            if(isdigit(ch))
            {   GetNewTmp();			/* get new temp varname */
            }
            else if(isalpha(ch))
            {   AddNewVar();			/* a variable name */
            }
            pi = e_pos;
            s_pos = pi;
            TO = find_strng("TO");		/* work up to: TO */
            TO--;
        }
    }
    e_pos = pi;
}
/*---------- end LexFor ----------*/


void ScanNumeric(char *name)
{   char ch, varname[VAR_NAME];
    int pi, type, len, ival, funcflag=0, ab_code=5, x=line_ndx;

/* printf("->Numer::%s", p_string); */
    strcpy(varname, name);
    pi = e_pos;
    len = strlen(varname);
    s_pos = pi - len;
    type = get_Nvtype(pi);			/* get var-type length */
	/**/
    Sav_Destin(type, varname);		/* save destination name */
	/**/
    pi = e_pos;  					/* handle expresions */
    len = strlen(p_string);
    while(pi < len)
    {   ch = p_string[pi];
        while((isalnum(ch) == 0) && (pi < len) && (strchr(".\"",ch) == 0))
        {   pi++;
            ch = p_string[pi];
            if(ch == '?')			/* math function: ?1(num) */
            {   e_pos = pi + 1;
                ival = (int) get_avalue();
                if((ival == 10) || (ival == 11) || (ival == 29))
                {   pi = len;				/* LOC, LOF, EOF */
                }
                else					/* any other function */
                {   pi = get_paren(pi, len);	/* ?num(string$) */
                    ch = p_string[pi];		/* ----^	     */
                    funcflag = 1;
                }
            }
        }
        if(pi < len)
        {   e_pos = pi;
            if(funcflag == 1)			/* this is a math function */
            {   ScanMathFunc(len);
                funcflag = 0;
            }
            else if((isdigit(ch)) || (ch == '.'))
            {   GetNewTmp();				/* get new temp varname */
            }
            else if(isalpha(ch))		/* an array or variable name */
            {   pi = e_pos;
                strcpy(varname, get_varname());		/* get varname */
                type = get_ObjectType(varname);
				/**/
                if((type >= 7) && (type <= 10))		/* an array name */
                {   Fix_VarArray(varname);
                    pi = e_pos;
                    pi = get_paren(pi, len);
                    ScanArrayParam();
                }
                else
                {   e_pos = pi;
                    AddNewVar();			/* a variable name */
                }
            }
            pi = e_pos;
            len = strlen(p_string);
        }
    }
/*  printf("ScanNumeric: %s", p_string); */
}
/*---------- end ScanNumeric ----------*/


void ScanMathFunc(int len)
{   char ch, varname[VAR_NAME];
    int pi, type;

/* printf("ScanMath::%s", p_string); */
    pi = e_pos;
    ch = p_string[pi];
    while((ch != ')') && (pi < len))
    {   if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();				/* get new varname */
        }
        else if((isdigit(ch)) || (ch == '.'))
        {   GetNewTmp();			/* get new temp varname */
        }
        else if(isalpha(ch))			/* a variable name */
        {   type = get_vtype(pi);		/* get variable type */
            if(type == 0)			/* string variables */
            {   strcpy(varname, get_varname());
                Fix_String(varname);
            }
            else if(type == 6)
            {   strcpy(varname, get_varname());
                Fix_StrArray(varname);
                pi = e_pos;
                pi = get_paren(pi, len);
                e_pos = pi;
                ScanArrayParam();
                pi = e_pos;
                pi++;
                e_pos = pi;
            }
            else
            {   AddNewVar();
            }
        }
        pi = e_pos;
        len = strlen(p_string);
        ch = p_string[pi];
        if(ch != ')')
        {   pi++;
            ch = p_string[pi];
            e_pos = pi;
        }
    }
/* printf("ScanMath::%s", p_string); */
}
/*---------- end ScanMathFunc ----------*/


void Sav_Destin(int type, char *Name)
{   char ch, varname[VAR_NAME];
    int pi, ab_code=5, x=line_ndx;

    strcpy(varname, Name);
    pi = e_pos;
    ch = p_string[pi];
		/**/
    if(strchr("%!#@&", ch))
    {   p_string[pi] = ' ';
    }
	/**/
    if((type == 1) || (type == 2))			/* 32-Bit Long Integer */
    {   if(check_VarName(varname) == 0)
        {   i_write_str("\t");
            i_write_str(varname);
            i_writeln("\t\tDD  ?");
			/**/
            Sav_ObjName(varname, type, 0);
        }
    }
    else if((type >= 3) && (type <= 5))
    {   if(check_VarName(varname) == 0)
        {   f_write_str("\t");
            f_write_str(varname);
            f_writeln("\t\tDQ  ?");
			/**/
            Sav_ObjName(varname, type, 0);
        }
    }
    else
    {   a_bort(ab_code, x);
    }
    StorNVar(varname);				/* save destination name */
}
/*---------- end Sav_Destin ----------*/


void AddNewVar()
{   char ch, varname[VAR_NAME];
    int pi, type;

    pi = e_pos;
    s_pos = pi;
  /* --- get varname --- */
    strcpy(varname, get_varname());
    pi = e_pos;

  /* --- get variable type --- */
    type = get_Nvtype(pi);
    Sav_Destin(type, varname);		/* save destination name */
}
/*---------- end AddNewVar ----------*/


void GetNewTmp()
{   char ch, NewVar[12], a_string[BUFSIZE];
    int pi, x=0, dotflag=0;
    double ftest=0;

    pi = e_pos;
    s_pos = pi;
    strcpy(NewVar, NewFVarname());
		/**/
    ch = p_string[pi];
    if(ch == '-')
    {   a_string[x] = ch;
        x++;
        pi++;
        ch = p_string[pi];
    }
    else if(ch == '.')
    {   a_string[x] = '0';
        x++;
    }
    while(isdigit(ch) || (ch == '.'))	/* copy digits */
    {   if(ch == '.')
        {   dotflag = 1;	/* flag: floating point number */
        }
        a_string[x] = ch;
        x++;
        pi++;
        ch = p_string[pi];
    }
    a_string[x] = '\0';
    e_pos = pi;
		/**/
  /* --- integers --- */
    if(dotflag == 0)
    {   ftest = atof(a_string);
        if(ftest <= 32767)
        {   strcat(NewVar, "I");
            write_str("\t");
            write_str(NewVar);		/* NewVar  DW  integer */
            write_str("\t\tDD  ");
			/**/
            Sav_ObjName(NewVar, 1, 0);
        }
        else if(ftest <= 2147483647)
        {   strcat(NewVar, "L");
            write_str("\t");
            write_str(NewVar);		/* NewVar  DD  long */
            write_str("\t\tDD  ");
			/**/
            Sav_ObjName(NewVar, 2, 0);
        }
        else
        {   strcat(NewVar, "Q");
            write_str("\t");
            write_str(NewVar);		/* NewVar  DD  long */
            write_str("\t\tDQ  ");
			/**/
            Sav_ObjName(NewVar, 5, 0);
        }
    }
		/**/
  /* --- floats --- */
    else
    {   ftest = atof(a_string);
        if(ftest <= 2147483647)
        {   strcat(NewVar, "F");
            write_str("\t");
            write_str(NewVar);		/* NewVar  DD  float */
            write_str("\t\tDQ  ");
			/**/
            Sav_ObjName(NewVar, 3, 0);
        }
        else
        {   strcat(NewVar, "D");
            write_str("\t");
            write_str(NewVar);		/* NewVar  DQ  double */
            write_str("\t\tDQ  ");
			/**/
            Sav_ObjName(NewVar, 4, 0);
        }
    }
    writeln(a_string);		/* write temp declaration */
		/**/
  /* --- save varname in array --- */
    StorNVar(NewVar); 
}
/*---------- end GetNewTmp ----------*/


void StorNVar(char *name)
{   char ch, varname[VAR_NAME];
    int pi, x=0, ii, len;
    unsigned size;

    strcpy(varname, name);
    len = strlen(varname);
    ii = (s_pos + len);				/* how many chars to xfer */
    if(s_pos > 0)
    {   for(x=0;x < s_pos; x++)
        {   s_holder[x] = p_string[x];
        }
        x = 0;
    }
    for(pi=s_pos; pi < ii; pi++,x++)
    {   s_holder[pi] = varname[x];			/* copy varname */
    }
    x = pi; 
    s_pos = pi;
    pi = e_pos;
    ch = p_string[pi];
    while(ch != '\0')
    {   s_holder[x] = p_string[pi];
        x++;
        pi++;
        ch = p_string[pi];
    }
    s_holder[x] = '\0';
    strcpy(p_string, s_holder);
		/**/
  /* --- save p_string to array --- */
    x = strlen(p_string);
    len = strlen(array1[line_ndx]);
    if(x > len)
    {  size = (x+1);
       ii = line_ndx;
       array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    }
    strcpy(array1[line_ndx], p_string);   	/* store to array */
		/**/
    ch = p_string[s_pos];
    if(isalpha(ch))
    {   s_pos = get_NextOp(s_pos);
    }
    e_pos = s_pos;
}
/*---------- end StorNVar ----------*/


char *NewFVarname()		/* generate a unique varname */
{   char Val[6];
    static char NVar[12];

    var_count++;
    strcpy(NVar, "VARX");
    sprintf(Val, "%d", var_count);
    strcat(NVar, Val);
    return NVar;
}
/*---------- end NewFVarname ----------*/





$CCODE